Package edu.wisc.game.rest

## Class TrialList

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - java.util.Vector<ParaSet>
      - - edu.wisc.game.rest.TrialList

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Iterable<ParaSet>`, `Collection<ParaSet>`, `List<ParaSet>`, `RandomAccess`

      public class TrialList
      extends Vector<ParaSet>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `TrialList.ExperimentPlanHandle` | Identifies an experiment plan as a static or dynamic (P: or R: type) one

  - ### Field Summary

    - ### Fields inherited from class java.util.Vector

      `capacityIncrement, elementCount, elementData`

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TrialList​(File mainFile)` | The original constructor: read the trial list from a single file!
    `TrialList​(String exp, String trialListId)` | Reads a trial list from the file that corresponds to a given experiment plan and the specified trial list id within that experiment.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static String` | `extractExperimentPlanFromPlayerId​(String playerId)` | To which experiment plan does this player ID belong?
    `String` | `getErrmsg()` |
    `boolean` | `getError()` |
    `String` | `getPath()` |
    `static Vector<String>` | `listTrialLists​(File base)` | Lists the names of the trial list files (with the extension removed) contained in a specified directory.
    `static Vector<String>` | `listTrialLists​(String exp)` | Lists the trialList IDs, i.e.
    `static HashMap<String,​Integer>` | `readDefects​(String exp)` |
    `void` | `setErrmsg​(String _errmsg)` |
    `void` | `setError​(boolean _error)` |
    `void` | `setPath​(String _path)` |

    - ### Methods inherited from class java.util.Vector

      `add, add, addAll, addAll, addElement, capacity, clear, clone, contains, containsAll, copyInto, elementAt, elements, ensureCapacity, equals, firstElement, forEach, get, hashCode, indexOf, indexOf, insertElementAt, isEmpty, iterator, lastElement, lastIndexOf, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, removeAllElements, removeElement, removeElementAt, removeIf, removeRange, replaceAll, retainAll, set, setElementAt, setSize, size, sort, spliterator, subList, toArray, toArray, toString, trimToSize`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, stream, toArray`

- - ### Constructor Detail

    - #### TrialList

          public TrialList​(String exp,
                           String trialListId)
                    throws IOException,
                           IllegalInputException

      Reads a trial list from the file that corresponds to a given experiment plan and the specified trial list id within that experiment.
      Parameters:
        `exp` - The name of an experiment plan (static or dynamic)
        `The` - trial list id (typically, file name of the trial list file, relative to the plan's directory, and fwithout extension). This should be null for R:-type dynamic plans.
      Throws:
        `IOException`
        `IllegalInputException`

    - #### TrialList

          public TrialList​(File mainFile)
                    throws IOException

      The original constructor: read the trial list from a single file!
      Throws:
        `IOException`

  - ### Method Detail

    - #### getError

          public boolean getError()

    - #### setError

          public void setError​(boolean _error)

    - #### getErrmsg

          public String getErrmsg()

    - #### setErrmsg

          public void setErrmsg​(String _errmsg)

    - #### getPath

          public String getPath()

    - #### setPath

          public void setPath​(String _path)

    - #### extractExperimentPlanFromPlayerId

          public static String extractExperimentPlanFromPlayerId​(String playerId)

      To which experiment plan does this player ID belong?

    - #### listTrialLists

          public static Vector<String> listTrialLists​(String exp)
                                               throws IOException

      Lists the trialList IDs, i.e. the names of the trial list files (with the extension removed), asscociated with a particular experiment plan. For an R: plan, returns the name of the rule set, because that's what will be recorded as the "trialListId" field in the PlayerInfo table.
      Parameters:
        `exp` - The name of the experiment plan (static or dynamic)
      Throws:
        `IOException`

    - #### listTrialLists

          public static Vector<String> listTrialLists​(File base)
                                               throws IOException

      Lists the names of the trial list files (with the extension removed) contained in a specified directory.
      Parameters:
        `base` - the directory (corresponding to one experiment plan) which contains trial list files
      Throws:
        `IOException`

    - #### readDefects

          public static HashMap<String,​Integer> readDefects​(String exp)